#include <cstdio>
#include <cstdlib>
#include <iostream>

using namespace std;

typedef long long LL;

class vec
{
	public:
		LL x, y, z;
		vec(LL _x = 0, LL _y = 0, LL _z = 0) : x(_x), y(_y), z(_z) { }

		vec operator- (const vec& b)
		{
			return vec(x-b.x, y-b.y, z-b.z);
		}	

		vec operator^ (const vec& b)
		{
			return vec(
					y*b.z-z*b.y,
					z*b.x-x*b.z,
					x*b.y-y*b.x
					);
		}

		LL operator* (const vec& b)
		{
			return x*b.x + y*b.y + z*b.z;
		}

		bool operator != (const vec& b)
		{
			return x!=b.x || y!=b.y || z != b.z;
		}
};

vec P[200000][3];
vec W[6];

#define REP(i,j) for(int i=0; i<(j); i++)

void reads(vec* vs)
{
	int n;
	LL x, y, z;

	scanf("%d", &n);
	REP(i,3)
		cin >> vs[i].x >> vs[i].y >> vs[i].z;
	REP(i,n-3)
		cin >> x >> y >> z;
}

LL s(vec& A, vec& B, vec& C, vec& X)
{
	vec p = (B-A)^(C-A);
	return (X-A)*p;
}

LL sw(vec& A, vec& B, vec& C)
{
	REP(i,6)
		if (A != W[i] && B != W[i] && C != W[i])
		{
			LL a = s(A, B, C, W[i]);
			if (a!=0) return a;
		}
	abort();
}

vec pts[200];
bool sure[200],ok[200];

int main()
{	
	int d;
	scanf("%d", &d);
	REP(t,d)
	{
		int m;
		scanf("%d", &m);
		REP(i,m)
			reads(P[i]);
		W[0] = P[0][0];
		W[1] = P[0][1];
		W[2] = P[0][2];
		W[3] = P[1][0];
		W[4] = P[1][1];
		W[5] = P[1][2];
		int n;
		scanf("%d", &n);
		REP(i,n)
		{
			LL x, y, z;
			cin >> x >> y >> z;
			pts[i] = vec(x,y,z);
			ok[i] = true;
			sure[i] = false;
		}
		REP(i,m)
		{
			vec* p = P[i];
			LL ds = sw(p[0], p[1], p[2]);
			if (ds > 0)
				ds = 1;
			else if (ds < 0)
				ds = -1;
			REP(j,n)
			{
				LL ss = s(p[0], p[1], p[2], pts[j]);
				if (!ss)
					sure[j] = true;
				if (ss*ds < 0)
					ok[j] = false;	
			}
		}
		REP(i,n)
			printf((sure[i]||ok[i])?"TAK\n":"NIE\n");
		printf("\n");
	}
	return 0;
}
