#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define REP(i,j) for (i=0; i<(j); i++)

struct list_head {
	struct list_head *next, *prev;
};

#define INIT_LIST_HEAD(ptr) do { \
	(ptr)->next = (ptr); (ptr)->prev = (ptr); \
} while (0)

static __inline__ void __list_add(struct list_head * nnew,
	struct list_head * prev,
	struct list_head * next)
{
	next->prev = nnew;
	nnew->next = next;
	nnew->prev = prev;
	prev->next = nnew;
}

static __inline__ void list_add(struct list_head *nnew, struct list_head *head)
{
	__list_add(nnew, head, head->next);
}

static __inline__ void __list_del(struct list_head * prev,
				  struct list_head * next)
{
	next->prev = prev;
	prev->next = next;
}

static __inline__ void list_del(struct list_head *entry)
{
	__list_del(entry->prev, entry->next);
	entry->next = entry->prev = 0;
}

static __inline__ int list_empty(struct list_head *head)
{
	return head->next == head;
}

#define list_for_each_safe(pos, n, head) \
	for (pos = (head)->next, n = pos->next; pos != (head); \
		pos = n, n = pos->next)

struct N
{
	struct N* ch[27];
	struct N* pop;
	char wz;
} __attribute__ ((packed));

struct N Nmem[500002];
int Nit;
struct N ROOT;
int wynik;

static inline struct N* alloc_N(void)
{
	return Nmem+(Nit++);
}

inline int c2num(char c)
{
	if (c == '*')
		return 26;
	return c - 'A';
}

struct N* dodw(struct N* p, int lit)
{
	if (p->ch[lit]) return p->ch[lit];
	struct N* ch = alloc_N();
	struct N* pop = p->pop;
	while (pop && !pop->ch[lit])
		pop = pop->pop;
	if (!pop)
		pop = &ROOT;
	else
		pop = pop->ch[lit];
	ch->pop = pop;
	ch->wz = 0;
	p->ch[lit] = ch;
	memset(ch->ch, 0, 27*sizeof(struct N*));
	return ch;
}

void szukaj(char* txt)
{
	struct N* n = &ROOT;
	while (*txt)
	{
		int c = c2num(*txt);
		while (n && !n->ch[c]) n = n->pop;
		if (!n)
			n = &ROOT;
		else
		{
			n = n->ch[c];
			if (n->wz)
			{
				wynik++;
				n = &ROOT;
			}
		}
		txt++;
	}
}

char* WZT;
char* WZTi;

struct WZ
{
	struct list_head list;
	struct N* p;
	char* text;
} __attribute__((packed));

struct WZ* WZWZ; //[150001];
struct list_head WZL;
char* text;

void pt(struct N* n, int d)
{
	int i, j;
	REP(i, 27)
	{
		if (n->ch[i])
		{
			REP(j, d) putchar(' ');
			printf("%c >>>\n", i+'A');
			pt(n->ch[i], d+1);
			REP(j, d) putchar(' ');
			printf("%c <<<\n", i+'A');
		}
	}
}

int main()
{
	int t, d;
	scanf("%d", &t);
	REP(d, t)
	{
		int n;
		int i;
		int j = 0;
		scanf("%d", &n);
		WZT = malloc(1000100);
		if (!WZT) abort();
		WZTi = WZT;
		wynik = 0;
		INIT_LIST_HEAD(&WZL);
		memset(ROOT.ch, 0, 27*sizeof(struct N*));
		Nit = 0;

		WZWZ = (struct WZ*)malloc(n*sizeof(struct WZ));
		if (!WZWZ) abort();

		REP(i, n)
		{
			int l;
			
			scanf("%s", WZTi);
			l = strlen(WZTi);
			if (l == 1)
			{
				int ll = c2num(*WZTi);
				if (!ROOT.ch[ll])
				{
					struct N* ch = alloc_N();
					ch->pop = &ROOT;
					ch->wz = 1;
					memset(ch->ch, 0, 27*sizeof(struct N*));
					ROOT.ch[ll] = ch;
				}
			}
			else
			{
				WZWZ[j].text = WZTi;
				WZWZ[j].p = &ROOT;
				WZTi += l+1;
				list_add(&WZWZ[j].list, &WZL);
				j++;
			}
		}

		while (!list_empty(&WZL))
		{
			struct list_head* it, * pom;
			list_for_each_safe(it, pom, &WZL)
			{
				struct WZ* in = (struct WZ*)it;
				//printf("%s\n", in->text);
				if (!*(in->text))
				{
					in->p->wz = 1;
					list_del(it);
				}
				else
					in->p = dodw(in->p, c2num(*(in->text)));
				in->text++;
			}
		}

		//pt(&ROOT, 0);
		free(WZT);
		free(WZWZ);
		text = malloc(5000100);
		if (!text) abort();
		scanf("%s", text);
		szukaj(text);
		free(text);
		printf("%d\n", wynik);
	}

	return 0;
}
