#include <cstdio>
#include <cstring>

using namespace std;

#define REP(i,j) for (int i=0; i<(j); i++)

struct list_head {
	struct list_head *next, *prev;
};

#define INIT_LIST_HEAD(ptr) do { \
	(ptr)->next = (ptr); (ptr)->prev = (ptr); \
} while (0)

static __inline__ void __list_add(struct list_head * nnew,
	struct list_head * prev,
	struct list_head * next)
{
	next->prev = nnew;
	nnew->next = next;
	nnew->prev = prev;
	prev->next = nnew;
}

static __inline__ void list_add(struct list_head *nnew, struct list_head *head)
{
	__list_add(nnew, head, head->next);
}

static __inline__ void __list_del(struct list_head * prev,
				  struct list_head * next)
{
	next->prev = prev;
	prev->next = next;
}

static __inline__ void list_del(struct list_head *entry)
{
	__list_del(entry->prev, entry->next);
	entry->next = entry->prev = 0;
}

static __inline__ int list_empty(struct list_head *head)
{
	return head->next == head;
}

#define list_for_each_safe(pos, n, head) \
	for (pos = (head)->next, n = pos->next; pos != (head); \
		pos = n, n = pos->next)

struct N
{
	N* ch[27];
	bool wz;
	N* pop;
};

N Nmem[500002];
int Nit;
N ROOT;
int wynik;

static inline N* alloc_N(void)
{
	return Nmem+(Nit++);
}

inline int c2num(char c)
{
	if (c == '*')
		return 26;
	return c - 'A';
}

N* dodw(N* p, int lit)
{
	if (p->ch[lit]) return p->ch[lit];
	N* ch = alloc_N();
	N* pop = p->pop;
	while (pop && !pop->ch[lit])
		pop = pop->pop;
	if (!pop)
		pop = &ROOT;
	else
		pop = pop->ch[lit];
	ch->pop = pop;
	ch->wz = 0;
	p->ch[lit] = ch;
	memset(ch->ch, 0, 27*sizeof(N*));
	return ch;
}

void szukaj(char* txt)
{
	N* n = &ROOT;
	while (*txt)
	{
		int c = c2num(*txt);
		while (n && !n->ch[c]) n = n->pop;
		if (!n)
			n = &ROOT;
		else
		{
			n = n->ch[c];
			if (n->wz)
			{
				wynik++;
				n = &ROOT;
			}
		}
		txt++;
	}
}

char WZT[1001000];
char* WZTi;

struct WZ
{
	list_head list;
	char* text;
	N* p;
};

WZ WZWZ[250000];
list_head WZL;
char text[5000001];

void pt(N* n, int d)
{
	REP(i, 27)
	{
		if (n->ch[i])
		{
			REP(j, d) putchar(' ');
			printf("%c >>>\n", i+'A');
			pt(n->ch[i], d+1);
			REP(j, d) putchar(' ');
			printf("%c <<<\n", i+'A');
		}
	}
}

int main()
{
	int t;
	scanf("%d", &t);
	REP(d, t)
	{
		int n;
		scanf("%d", &n);
		WZTi = WZT;
		wynik = 0;
		INIT_LIST_HEAD(&WZL);
		Nit = 0;

		REP(i, n)
		{
			WZWZ[i].text = WZTi;
			WZWZ[i].p = &ROOT;
			scanf("%s", WZTi);
			//printf("%s\n", WZTi);
			WZTi += strlen(WZTi)+1;
			list_add(&WZWZ[i].list, &WZL);
		}

		while (!list_empty(&WZL))
		{
			list_head* it, * pom;
			list_for_each_safe(it, pom, &WZL)
			{
				WZ* in = (WZ*)it;
				printf("%s\n", in->text);
				if (!*(in->text))
				{
					in->p->wz = true;
					list_del(it);
				}
				else
					in->p = dodw(in->p, c2num(*(in->text)));
				in->text++;
			}
		}

		//pt(&ROOT, 0);
		scanf("%s", text);
		szukaj(text);
		printf("%d\n", wynik);
	}

	return 0;
}
